discy/urls.py
from django.urls import path
from discy import views
app_name = 'discy'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('signout/', views.LogoutView.as_view(), name='signout'),
    path('signin/', views.LoginView.as_view(), name='signin'),
    path('signup/', views.SignUpView.as_view(), name='signup'),
    path('index1/', views.index1, name='index1'),
    path('askquestion/', views.AskQuestionView.as_view(), name='askquestion'),
    path('postanswer/', views.AnswerView.as_view(), name='postanswer'),
    path('search/', views.SearchView.as_view(), name='search'),

]

newsite/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('', include('discy.urls')),
    path('admin/', admin.site.urls),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

discy/models.py
from ckeditor.fields import RichTextField
from django.db import models
from django.contrib.auth.models import (BaseUserManager, AbstractBaseUser)
from django_extensions.db.models import TimeStampedModel
from discy.roles import EMPLOYEE_TYPES


class MyUserManager(BaseUserManager):
    def create_user(self, email, date_of_birth, password=None):
        """
        Creates and saves a User with the given email, date of
        birth and password.
        """
        if not email:
            raise ValueError('Users must have an email address')

        user = self.model(
            email=self.normalize_email(email),
            date_of_birth=date_of_birth,
        )

        user.set_password(password)
        user.save(using=self._db)
        return user

    def create_superuser(self, email, date_of_birth, password=None):
        """
        Creates and saves a superuser with the given email, date of
        birth and password.
        """
        user = self.create_user(
            email,
            password=password,
            date_of_birth=date_of_birth,
        )
        user.is_admin = True
        user.save(using=self._db)
        return user


class MyUser(AbstractBaseUser):
    email = models.EmailField(
        verbose_name='email address',
        max_length=255,
        unique=True,
    )
    # date_of_birth = models.DateField()
    is_active = models.BooleanField(default=True)
    is_admin = models.BooleanField(default=False)
    is_staff = models.BooleanField(default=False)
    # username = models.CharField(max_length=255, null=True)
    first_name = models.CharField(max_length=255, null=True)
    last_name = models.CharField(max_length=255, null=True)
    # age = models.CharField(max_length=30, null=True)

    objects = MyUserManager()

    USERNAME_FIELD = 'email'
    # REQUIRED_FIELDS = ['date_of_birth']
    REQUIRED_FIELDS = ['first_name', 'last_name']

    def __str__(self):
        return self.email

    def has_perm(self, perm, obj=None):
        "Does the user have a specific permission?"
        # Simplest possible answer: Yes, always
        return True

    def has_module_perms(self, app_label):
        "Does the user have permissions to view the app `app_label`?"
        # Simplest possible answer: Yes, always
        return True

    @property
    def is_staff(self):
        "Is the user a member of staff?"
        # Simplest possible answer: All admins are staff
        return self.is_admin

    def get_full_name(self):
        return "{}{}".format(self.first_name or "", self.last_name or "")


class Question(models.Model):
    question_text = models.CharField(max_length=255)
    question_category = models.CharField(max_length=255)
    pub_date = models.DateTimeField(auto_now_add=True)
    first_name = models.CharField(max_length=255, null=True)
    last_name = models.CharField(max_length=255, null=True)
    user = models.ForeignKey(MyUser, on_delete=models.CASCADE, related_name='question')

    class Meta:
        verbose_name = "Question"
        verbose_name_plural = "Questions"

    def __str__(self):
        return self.question_text


class Answer(models.Model):
    question_id = models.ForeignKey(Question, on_delete=models.CASCADE, blank=False, null=True, related_name='answer')
    answer_text = models.TextField(max_length=1000)
    pub_date = models.DateTimeField(auto_now_add=True)
    user = models.ForeignKey(MyUser, on_delete=models.CASCADE, related_name='answer')

    def __str__(self):
        return self.answer_text


class Organisation(models.Model):
    name = models.CharField(max_length=30, null=True, blank=True)
    city = models.CharField(max_length=30, null=True, blank=True)

    class Meta:
        verbose_name = 'Organisation'
        verbose_name_plural = 'Organisations'

    def __str__(self):
        return self.name


class UserOrg(TimeStampedModel):
    user = models.ForeignKey(MyUser, on_delete=models.CASCADE)
    organisation = models.ForeignKey(Organisation, on_delete=models.CASCADE, null=True, blank=True)

    role = models.CharField(max_length=30, null=True, choices=EMPLOYEE_TYPES)

    class Meta:
        verbose_name = 'UserOrg'
        verbose_name_plural = 'UserOrges'

    def __str__(self):
        return self.user.first_name


# class Employee(TimeStampedModel):
#     org_name = models.ManyToManyField('Organisation',through=UserOrg, related_name='Employee')
#     employee = models.ManyToManyField('MyUser', through=UserOrg, related_name='employee')
#     role = models.CharField(max_length=25, choices=EMPLOYEE_TYPES)
#
#     class Meta:
#         verbose_name = 'Employee'
#         verbose_name_plural = 'Employees'
#
#     def __str__(self):
#         return self.role

discy/forms.py
from django import forms
from discy.models import *


class UserForm(forms.ModelForm):
    confirm_password = forms.PasswordInput()

    class Meta:
        model = MyUser
        fields = '__all__'

    # def is_valid(self):
    #     if MyUser.objects.filter(email=self.data['email']).exists():
    #         raise forms.ValidationError({"error": "user is already exist"})
    #     return self.data


class Askquestion(forms.ModelForm):
    class Meta:
        model = Question
        fields = ['question_text', 'question_category', 'user', 'first_name', 'last_name']


class Postanswer(forms.ModelForm):
    class Meta:
        model = Answer
        fields = ['answer_text', 'question_id', 'user']

discy/views.py
from django.shortcuts import render, redirect
from .models import *
from django.views import View, generic
from django.contrib.auth import authenticate, login, logout
from .forms import UserForm, Askquestion, Postanswer
from django.urls import reverse_lazy
from django.views.generic.base import TemplateView
from django.views.generic.edit import FormView


class IndexView(View):
    template_name = 'discy/index.html'

    def get(self, request, *args, **kwargs):
        answers = Answer.objects.all()
        queryset = Question.objects.all()
        recent_question = Question.objects.order_by('-pub_date')[:2]
        recent_answer = Answer.objects.order_by('-pub_date')[:1]

        return render(request, 'discy/index.html',
                      {'questions': queryset, 'recent_question': recent_question, "user": request.user,
                       'answers': answers,
                       "recent_answer": recent_answer})


def index1(request):
    return render(request, 'discy/index1.html')


class AskQuestionView(View):
    form_class = Askquestion
    template_name = 'discy/index1.html'
    success_url = reverse_lazy('discy:index')

    def post(self, request, *args, **kwargs):
        form = self.form_class(request.POST)
        if form.is_valid():
            form.save()
        else:
            return redirect('discy:askquestion')
        return redirect('discy:index')


class AnswerView(View):
    form_class = Postanswer
    template_name = 'discy/index.html'
    success_url = reverse_lazy('discy:index')

    def post(self, request, *args, **kwargs):
        form = self.form_class(request.POST)
        if form.is_valid():
            form.save()
        else:
            return redirect('discy:index')

        return redirect('discy:index')


class SignUpView(FormView):
    template_name = 'discy/index.html'
    form_class = UserForm
    success_url = reverse_lazy('discy:index')

    def form_valid(self, form):
        form.save()
        user = MyUser.objects.get(email=form.data.get('email'))
        user.is_active = True
        user.set_password(form.data.get('password'))
        user.save()
        return super(SignUpView, self).form_valid(form)


class LoginView(View):
    template_name = 'discy/index.html'

    def post(self, request, *args, **kwargs):
        email = request.POST.get("email")
        password = request.POST.get("password")
        user = authenticate(email=email, password=password)
        if user is not None:
            login(request, user)
            print("user created")
            return redirect('discy:index')

        else:
            return redirect('discy:index')


class LogoutView(View):
    template_name = 'discy/index.html'

    def get(self, request, *args, **kwargs):
        logout(request)
        return redirect('discy:index')


class SearchView(View):
    template_name = 'search.html'

    def get(self, request, *args, **kwargs):
        query = self.request.GET['query']
        recent_answer = Answer.objects.order_by('-pub_date')[:1]
        answers = Answer.objects.all()
        searched = Question.objects.filter(
            question_text__icontains=query
        )
        return render(request, 'discy/search.html', {'searched': searched, 'recent_answer': recent_answer,
                                                     'answers': answers})

discy/templates/discy/base.html
<!DOCTYPE html>
{% load static %}
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta content="width=device-width, initial-scale=1" name="viewport">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.0/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://fonts.googleapis.com/css?family=Montserrat:300,400,400i,500,600,700&display=swap"
          rel="stylesheet">
    <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.css" rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="{% static 'discy/question.css' %}">

</head>
<body>

{% include 'discy/header.html' %}
{% block content %}
{% endblock %}
{% include 'discy/footer.html' %}
{
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.0/js/bootstrap.min.js"></script>


</body>
</html>

discy/templates/discy/footer.html
{% load static %}
{% block content %}
<div class="container-fluid footer">
    <div class="container">
        <div class="col-md-12 footer-div">
            <div class="col-md-4 footer1">
                <img src="{%static 'discy/img/logo-footer.png' %}"/>
                <p>Discy is a social questions & Answers Engine which will help you establis your community and connect
                    with other people.</p>
            </div>
            <div class="col-md-4 footer2">
                <h4>About us</h4>
                <ul>
                    <li>
                        <a href="#">
                            <h5>Meet the team</h5>
                        </a>
                        <a href="#">
                            <h5>Contact us </h5>
                        </a>
                        <a href="#">
                            <h5>About us</h5>
                        </a>
                    </li>
                </ul>
            </div>
            <!---Links--->
            <div class="col-md-4 footer3">
                <h4>Follow</h4>
                <ul>
                    <li>
                        <a href="#">
                            <img src="{%static 'discy/img/ficon.png' %}"/>
                        </a>
                        <a href="#">
                            <img src="{%static 'discy/img/insta.png' %}"/>
                        </a>
                        <a href="#">
                            <img src="{%static 'discy/img/twitter.png' %}"/>
                        </a>
                        <a href="#">
                            <img src="{%static 'discy/img/linkedin.png' %}"/>
                        </a>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</div>

{% endblock %}

discy/templates/discy/header.html
{% load static %}
{% block content %}

    <nav class="navbar navbar-inverse header">
        <div class="container-fluid  padding0">
            <div class="col-md-12 padding-xs-0">
                <div class="col-md-3 col-sm-2 col-xs-12">
                    <div class="navbar-header">
                        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#myNavbar">
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                        </button>
                        <a href="#">
                            <img class="img-responsive logo-image" src="{% static 'discy/img/logo.png' %}"/>
                        </a>
                    </div>
                </div>
                <div class="col-md-8 col-sm-10 col-xs-12">
                    <div class="collapse navbar-collapse" id="myNavbar">
                        <div class="col-sm-9 col-xs-12">
                            <ul class="nav navbar-nav">
                                <li class="active homepadd"><a href="{% url 'discy:index' %}">Home</a></li>
                                <li class="homepadd"><a href="#">About Us</a></li>
                                <li class="homepadd1">
                                    <form method="get" action="{% url 'discy:search'%}" class="side-div">
                                        <input class="form-control" id="query" name="query" placeholder="Type of Search.."
                                               type="search">
                                        <button class="btn" type="submit"><i class="fa fa-search"></i></button>
                                    </form>
                                </li>
                            </ul>
                        </div>

                    {% if user.is_authenticated %}
                        <div class="col-md-1 padding0">
                        <h3>@{{ user.get_full_name }}</h3>
                            <button class="btn btn-info btn-lg btn-insign"
                                    type="button"><a href="{% url 'discy:signout' %}">Logout</a>
                            </button>
                        </div>
                    {% else %}
                        <div class="col-md-1 padding0">
                            <button class="btn btn-info btn-lg btn-insign" data-target="#signin" data-toggle="modal"
                                    type="button">Sign in
                            </button>
                        </div>
                        <div class="col-md-1">
                            <button class="btn btn-info btn-lg btn-upsign" data-target="#signup" data-toggle="modal"
                                    type="button">Sign up
                            </button>
                        </div>
                    {% endif %}
                    </div>
                </div>
            </div>
        </div>
    </nav>



    <!-- Sign In Modal -->
    <div class="modal fade model-insign" id="signin" role="dialog">
        <div class="modal-dialog">

            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-header">
                    <button class="close active" data-dismiss="modal" type="button">&times;</button>
                    <h4>Sign in</h4>
                    <p>Login to our social questions & Answers Engine to ask questions answer
                        people’s questions & connect with other people.</p>
                </div>

                <div class="modal-body">
                    <div class="col-md-12 col-sm-12 col-xs-12">
                        <div class="col-md-5 col-xs-5 col-sm-5 modeldiv">
                            <button type="button">sign up here</button>
                        </div>
                        <div class="col-md-7 col-xs-7 col-sm-7 username">
                            <form action="{% url 'discy:signin' %}" method="POST">
                                {% csrf_token %}
                                <div class="form-group">
                                    <label for="usr">Username:</label>
                                    <input class="form-control user-xs" name="email" id="usr" type="email">
                                </div>
                                <div class="form-group">
                                    <label for="pwd">Password:</label>
                                    <input class="form-control" id="pwd" name="password" type="password">
                                </div>
                                <div class="col-md-12 padding0">
                                    <div class="col-md-6 padding0">
                                        <div class="checkbox">
                                            <label><input type="checkbox" value="">Remember Me!</label>
                                        </div>
                                    </div>
                                    <div class="col-md-6 forget-password padding0">
                                        <a href="#">
                                            <h6>Forget Your Password? </h6>
                                        </a>
                                    </div>
                                </div>
                                <button class="inlog">Log In</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Sign Up Modal -->
    <div class="modal fade model-upsign" id="signup" role="dialog">
        <div class="modal-dialog">

            <!-- Modal content-->
            <div class="modal-content content-padd">
                <div class="modal-header">
                    <button class="close" data-dismiss="modal" type="button">&times;</button>
                    <h4>Sign up</h4>
                    <p>Login to our social questions & Answers Engine to ask questions answer people’s
                        questions & connect with other people.</p>
                </div>
                <div class="modal-body">
                    <div class="col-md-12 col-xs-12 col-sm-12">
                        <div class="col-md-5 col-xs-5 col-sm-5 upsign-div">
                            <button class="btn">Have an account? Sign in</button>
                        </div>
                        <div class="col-md-7 col-xs-12 col-sm-12 upsign-userdiv">
                            <form action="{% url 'discy:signup' %}" method="post"  enctype="multipart/form-data">
                                {% csrf_token %}
{#                                <div class="form-group">#}
{#                                    <label for="user">Username:</label>#}
{#                                    <input class="form-control" name="username" id="user" type="text">#}
{#                                </div>#}
                                <div class="form-group">
                                    <label for="password">First name:</label>
                                    <input class="form-control" name="first_name" id="name" type="text">
                                </div>
                                <div class="form-group">
                                    <label for="password">Last name:</label>
                                    <input class="form-control" name="last_name" id="" type="text">
                                </div>
                                <div class="form-group">
                                    <label for="email">E-mail:</label>
                                    <input class="form-control" name="email" id="email" type="email">
                                </div>
                                <div class="form-group">
                                    <label for="password">Password:</label>
                                    <input class="form-control" name="password" id="password" type="password">
                                </div>
                                <div class="form-group">
                                    <label for="password">Confirm Password:</label>
                                    <input class="form-control" name="confirm_password" id="confirm_password"
                                           type="password">
                                </div>
{#                                <div class="form-group">#}
{#                                    <label for="birthday">Date of birth:</label>#}
{#                                    <input type="date" id="birthday" name="date_of_birth">#}
{#                                </div>#}
{#                                <div>#}
{#                                    <label for="img">Select image:</label>#}
{#                                    <input type="file" id="img" name="image" accept="image/jpeg">#}
{#                                </div>#}
                                <div class="checkbox">
                                    <label><input type="checkbox" value="">I agree with the T&C</label>
                                </div>
                                <button type="submit" class="btn btn-primary">Sign up</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>

{% endblock %}

discy/templates/discy/search.html
{% extends 'discy/base.html'%}
{% load static %}
{% block content %}
<div class="container-fluid nav-div main-content">
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <!--side-bar-->
                <div class="col-md-2 nav-home">
                    <ul>
                        <li class="active">
                            <a href="#">
                                <h5><i class="fa fa-home"></i> Home {{ user.get_full_name }}</h5>
                            </a>
                        </li>
                        <li class="dropdown">
                            <a class="dropdown-toggle" data-toggle="dropdown" href="#"><i class="fa fa-book"></i>
                                Question</a>
                            <ul class="dropdown-menu">
                                <li><a href="#"><i aria-hidden="true" class="fa fa-quora"></i>New Questions</a></li>
                                <li><a href="#"><i aria-hidden="true" class="fa fa-quora"></i>Tranding Questions</a>
                                </li>
                                <li><a href="#"><i aria-hidden="true" class="fa fa-quora"></i>Most read Questions</a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                    <!---top questions--->
                    <div class="col-md-12 padding0">
                        <div class="col-md-12 top-div">
                            <h4>Top Questions</h4>
                        </div>
                        <div class="col-md-12 top2-div">
{#                            {% for i in questions %}#}
{#                            <div class="col-md-12 top1-div">#}
{#                                <h5>{{i.question_text}}</h5>#}
{#                                <a href="#"> <i aria-hidden="true" class="fa fa-commenting"></i>4 Answers</a>#}
{#                            </div>#}
{#                            {% endfor %}#}
                        </div>
                    </div>
                </div>
                <!---middle-tab--->
                <div class="col-md-7 middle-table">
                    <ul class="nav nav-tabs nav-middle">
                        <li class="active">
                            <a data-toggle="tab" href="#recent_questions">Search results....</a>
                        </li>
                    </ul>
                    <!--tab-content-->
                    <div class="tab-content">
                        <div class="tab-pane fade in active" id="recent_questions">
                            {% for i in searched %}
                            <div class="col-md-12 tabcontent-div">
                                <div class="col-md-2 padding0 tab-text dropdown">
                                    <a class="dropbtn" href="#">
                                        <img class="img-responsive" alt="author-img" src="{{ i.user.image.url }}"/>
                                    </a>
                                    <div class="dropdown-content">
                                        <div class="col-md-12 dropdown-image">
                                            <a>
                                                <img class="img-responsive" src="{{ i.user.image.url }}"/>
                                            </a>
                                        </div>
                                        <div class="col-md-12 dropdown-name">
                                            <h6>{{ i.get_full_name }}</h6>
                                            <ul>
                                                <li>
                                                    <img class="img-responsive" src="{%static 'discy/img/placeholder.svg' %}"/>
                                                    <p>Gurgaon ,Haryana</p>
                                                </li>
                                            </ul>
                                        </div>

                                        <div class="col-md-12 dropdown-text">
                                            <a href="#"><i aria-hidden="true" class="fa fa-question-circle"></i>3
                                                Questions</a>
                                            <a href="#"><i aria-hidden="true" class="fa fa-commenting"></i>12
                                                Answers</a>
                                            <a href="#"><i aria-hidden="true" class="fa fa-eye"></i>146 Points</a>
                                        </div>

                                    </div>
                                </div>

                                <!---author-details-->
                                <div class="col-md-10 padding0">
                                    <div class="col-md-12 author-details">
                                        <h5>{{i.first_name}} {{i.last_name}}</h5>
                                        <p>Asked:{{i.pub_date }}</p>
                                    </div>
                                    <div class="col-md-12 author-quote">
                                        <a href="#"><h4>{{i.question_text}}</h4></a>
                                    </div>
                                    {% for a in recent_answer %}
                                    <div class="col-md-12 padding0">
                                        <p class="author-para">{{ a.answer_text }}</p>
                                    </div>
                                        {% endfor %}
                                    <div class="col-md-12 padding0">
                                        <button class="author-button">English</button>
                                        <button class="author-button">Language</button>
                                    </div>
                                </div>

                                <div class="col-md-12 answer-sec">
                                        <a href="#"> <i aria-hidden="true" class="fa fa-commenting"></i> 4 Answer</a>
                                        <a href="#"><i aria-hidden="true" class="fa fa-eye"></i>1k Views</a>
                                        <button>Answer</button>
                                    </div>
                                    <div class="col-md-12 answer1-sec">
                                        <a href="#"><i aria-hidden="true" class="fa fa-arrow-circle-up"></i> Upvote
                                            :1.5k</a>
                                        <a class="answer2-sec" href="#"><i aria-hidden="true"
                                                                           class="fa fa-arrow-circle-down"></i><i
                                                aria-hidden="true" class="fa fa-ellipsis-h"></i></a>
                                    </div>
                                <!---answer-highlight-->
                                <div class="col-md-12 col-xs-12">
                                    {% for answer in answers %}
                                        {% if answer.question_id.id == i.id %}
                                    <div class="row ans1-added">
                                        <div class="col-md-12 answer-highlight ans-added">
                                            <div class="col-md-12 addcomment1">
                                                <a href="#"><img src="{{ answer.user.image.url }}"/>{{answer.user.first_name}} {{answer.user.last_name}}</a>
                                            </div>
                                            <div class="col-xs-12 padding0">
                                                <p>{{answer.answer_text}}</p>
                                            </div>
                                        </div>
                                    </div>
                                        {% endif %}
                                        {% endfor %}
                                </div>
                            </div>
                            {% endfor %}
                        </div>

                    </div>
                </div>
                <!---Ask a Question--->
                <div class="col-md-3 col-xs-12 col-sm-12 aska-div">
                    <div class="col-md-12  col-xs-12 col-sm-12 ask-question">
                        <button class="btn btn-info btn-lg btn-insign1" data-target="#ask_a_question1" data-toggle="modal"
                                 {% if user.is_authenticated %}
                                    type="button"><a href="{% url 'discy:index1' %}">Ask A Question</a>
                                 {% else %}
                                    type="button"><a href="{% url 'discy:index' %}">Ask A Question</a>
                                 {% endif %}
                        </button>
                    </div>


                    </div>

                </div>

            </div>
        </div>
    </div>

{% endblock %}